from core.callbacks.sdt.episode_callback import EpisodeCallbackTemplate
from core.experiment.config import TreeConfiguration


#####################
# TreeConfiguration #
#####################
def get_tree_configurations(depths, lmbda, sdt_batch_size):
    # The list of tree configurations
    tree_configurations = []
    # Generate tree configurations for all depths
    for depth in depths:
        tree_config = TreeConfiguration(depth, lmbda, sdt_batch_size, name=f'Depth_{depth}')
        tree_configurations.append(tree_config)
    # Return the configurations
    return tree_configurations


#################
# SDT Callbacks #
#################
def get_episode_callbacks(episode_templates, training_agent, agent_warm_up_steps,
                          epochs, save_epoch_interval, log_interval):
    # Generate the episode callbacks
    episode_callbacks = []
    for (episode_interval, episodes) in episode_templates:
        callback_template = EpisodeCallbackTemplate(episode_interval, episodes, training_agent, agent_warm_up_steps,
                                                    epochs=epochs,
                                                    save_epoch_interval=save_epoch_interval, log_interval=log_interval)
        episode_callbacks.append(callback_template)
    # Return the callback templates
    return episode_callbacks
