import gym

from lib.mario_gym.gym_envs.mario import UnaryMarioAction

# Let's set OpenAI Gym's logger to DEBUG mode
gym.logger.set_level(gym.logger.DEBUG)

if __name__ == '__main__':

    # see gym_envs/__init__.py for alternative Mario envs
    # Using context management (aka the "with" statement) gives us automatic environment cleanup
    with gym.make('MarioVisual-v0', fps=100, vis='on') as env:  # 100 fps gives max speed in mario emulator, default: 24
        env = UnaryMarioAction(env)  # wrapper to reduce the action space from all possible combinations of button presses to only individual button presses
        env.reset()
        for i in range(300):
            print(f"Step {i}")
            # Random action sampling
            env.step(env.action_space.sample())
            # To "see" the receptive field (actual environment state)
            env.render()

    # Without context management we have to manually close the Gym environment once we're  done with it
    # env = gym.make('Mario-v0', fps=100, vis='on')
    # env = UnaryMarioAction(env)  # wrapper to reduce the action space from all possible combinations of button presses to only individual button presses
    # env.reset()
    # for i in range(300):
    #     # Random action sampling
    #     env.step(env.action_space.sample())
    #     # To "see" the receptive field (actual environment state)
    #     env.render()
    # env.close()
